//==============================================================================================================================================
// ПЕРЕМЕННЫЕ МОДУЛЯ
//==============================================================================================================================================

//==============================================================================================================================================
// ОБРАБОТЧИКИ СОБЫТИЙ ФОРМЫ
//==============================================================================================================================================

//==============================================================================================================================================
// ОБРАБОТЧИКИ КОМАНД ФОРМЫ
//==============================================================================================================================================

&НаКлиенте
Процедура Загрузить(Команда)
	
	Если Не ЗначениеЗаполнено(БанковскаяКарта) Тогда
		Сообщить("Необходимо указать банковскую карту");
		Возврат;
	КонецЕсли;
	
	ЗагрузитьСервер();
	Оповестить("ЗагруженыНовыеЗаписи");
	Закрыть();
	
КонецПроцедуры // Загрузить()

//==============================================================================================================================================
// ОБРАБОТЧИКИ СОБЫТИЙ ЭЛЕМЕНТОВ ФОРМЫ
//==============================================================================================================================================

//==============================================================================================================================================
// КЛИЕНТСКИЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

//==============================================================================================================================================
// КЛИЕНТ-СЕРВЕРНЫЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

//==============================================================================================================================================
// СЕРВЕРНЫЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

&НаСервере
Процедура ЗагрузитьСервер()
	
	Запрос = Новый Запрос();
	
	Запрос.Текст = "
		|ВЫБРАТЬ
		|	Ссылка,
		|	Определение
		|ИЗ
		|	Справочник.ВидыДоходовРасходов.ТаблицаОпределений
		|ГДЕ
		|	Ссылка.ПометкаУдаления = ЛОЖЬ
		|";
	
	ТаблицаОпределений = Запрос.Выполнить().Выгрузить();
	
	Запрос.УстановитьПараметр("Дата", ТекущаяДата() - 24 * 60 * 60 * 365); // Последний год.
	
	Запрос.Текст = "
		|ВЫБРАТЬ
		|	*
		|ИЗ
		|	РегистрСведений.ФактическиеДвижения
		|ГДЕ
		|	Дата >= &Дата
		|	И ПризнакРучногоИзменения = ИСТИНА
		|";
	
	ТаблицаСуществующихЗаписей = Запрос.Выполнить().Выгрузить();
	СтруктураПоиска = Новый Структура("БанковскаяКарта, Дата, Валюта");
	
	ТекущаяДатаОперации 	= Неопределено;
	ТекущееВремяОперации 	= 0;
	
	Для НомерСтроки = 1 По СтрЧислоСтрок(ОписаниеОпераций) Цикл
		
		СтрокаОперации 	= СтрПолучитьСтроку(ОписаниеОпераций, НомерСтроки);
		МассивОперации 	= СтрРазделить(СтрокаОперации, Символы.Таб);
		ВсегоЗначений 	= МассивОперации.Количество();
		
		// Поддерживаемые форматы:
		//	1. ГПБ. Список операций банковской карты. Значений - 4.
		//		1.1. Дата операции, длина 25.
		//		1.2. Комментарий операции.
		//		1.3. Валюта и сумма в валюте.
		//		1.4. RUR и сумма в рублях.
		//	2. ГПБ. Выписка со счета. Значений - 5.
		//		2.1. Дата расчета, длина 10.
		//		2.2. Дата операции, длина 10.
		//		2.3. Содержание операции.
		//		2.4. Сумма операции в валюте счета.
		//		2.5. Остаток.
		//	3. Кукуруза. Выписка со счета. Значений - 7.
		//		3.1. Дата (без времени), длина 10.
		//		3.2. Код карточки.
		//		3.3. Вид операции.
		//		3.4. Комментарий.
		//		3.5. Сумма списания.
		//		3.6. Сумма зачисления.
		//		3.7. Остаток.
		
		ВидФормата = Неопределено;
		Если ВсегоЗначений = 4 И СтрДлина(МассивОперации[0]) = 25 Тогда
			ВидФормата = 1;
		ИначеЕсли ВсегоЗначений = 5 И СтрДлина(МассивОперации[0]) = 10 И СтрДлина(МассивОперации[1]) = 10 Тогда
			ВидФормата = 2;
		ИначеЕсли ВсегоЗначений = 7 И СтрДлина(МассивОперации[0]) = 10 Тогда
			ВидФормата = 3;
		КонецЕсли;
		
		Если ВидФормата = Неопределено Тогда
			Сообщить("Неподдерживаемый формат загрузки в строке " + НомерСтроки);
			Продолжить;
		КонецЕсли;
		
		Если ВидФормата = 1 Тогда
			
			ДатаОперации 		= МассивОперации[0];
			КомментарийОперации = МассивОперации[1];
			СуммаВВалюте 		= МассивОперации[2];
			Сумма 				= МассивОперации[3];
			
			ДатаОперации = Дата(Сред(ДатаОперации, 7, 4) + Сред(ДатаОперации, 4, 2) + Лев(ДатаОперации, 2)
				+ Сред(ДатаОперации, 12, 2) + Сред(ДатаОперации, 15, 2) + Сред(ДатаОперации, 18, 2));
			
			СтруктураСуммыВВалюте 	= ПолучитьСуммуИВалюту(СуммаВВалюте);
			СтруктураСуммы 			= ПолучитьСуммуИВалюту(Сумма);
			
			Валюта 			= СтруктураСуммыВВалюте.Валюта;
			Сумма 			= СтруктураСуммы.Сумма;
			СуммаВВалюте	= СтруктураСуммыВВалюте.Сумма;
			
		ИначеЕсли ВидФормата = 2 Тогда
			
			ДатаОперации 		= МассивОперации[1];
			КомментарийОперации = МассивОперации[2];
			Сумма 				= Число(СтрЗаменить(МассивОперации[3], " ", ""));
			
			ДатаОперации = Дата(Сред(ДатаОперации, 7, 4) + Сред(ДатаОперации, 4, 2) + Лев(ДатаОперации, 2));
			
			// В дате операции этого формата нет времени, поэтому просто прибавляем одну секунду, если операция в той же дате, что и предыдущая.
			Если ДатаОперации <> ТекущаяДатаОперации Тогда
				ТекущаяДатаОперации = ДатаОперации;
				ТекущееВремяОперации = 0;
			Иначе
				ТекущееВремяОперации = ТекущееВремяОперации + 1;
			КонецЕсли;
			
			ДатаОперации = ДатаОперации + ТекущееВремяОперации;
			
			Валюта 				= "RUR";
			СуммаВВалюте 		= Сумма;
			
			// Валюта и сумма есть только в комментарии.
			НомерВалюты = СтрНайти(КомментарийОперации, "Валюта операции: ");
			НомерСуммы 	= СтрНайти(КомментарийОперации, "Сумма операции: ");
			Если НомерВалюты > 0 И НомерСуммы > 0 Тогда
				
				СтрокаВалюты 		= Сред(КомментарийОперации, НомерВалюты);
				СтрокаВалюты 		= СтрЗаменить(СтрокаВалюты, "Валюта операции: ", "");
				Валюта 				= СокрЛП(СтрЗаменить(СтрокаВалюты, ".", ""));
				
				КомментарийДляСуммы = Лев(КомментарийОперации, НомерВалюты - 1);
				СтрокаСуммы 		= Сред(КомментарийДляСуммы, НомерСуммы);
				СтрокаСуммы 		= СокрЛП(СтрЗаменить(СтрокаСуммы, "Сумма операции: ", ""));
				СтрокаСуммы 		= Лев(СтрокаСуммы, СтрДлина(СтрокаСуммы) - 1);
				СуммаВВалюте 		= Число(СтрокаСуммы);
				СуммаВВалюте 		= СуммаВВалюте * ?(Сумма < 0, -1, 1);
				
			КонецЕсли;
			
		ИначеЕсли ВидФормата = 3 Тогда
			
			ДатаОперации 		= МассивОперации[0];
			ВидОперации 		= МассивОперации[2];
			КомментарийОперации = МассивОперации[3];
			СуммаСписания 		= СокрЛП(МассивОперации[4]);
			СуммаЗачисления 	= СокрЛП(МассивОперации[5]);
			ЭтоСписание 		= ЗначениеЗаполнено(СуммаСписания);
			Сумма 				= ?(ЭтоСписание, СуммаСписания, СуммаЗачисления);
			
			Сумма = Число(СтрЗаменить(Сумма, ",", ""));
			Сумма = Сумма * ?(ЭтоСписание, -1, 1);
			
			// В случае покупки комментарий примерно следующего вида:
			//	Cистема MasterCard. Документ на операцию ID: 306055529,
			//		Дата совершения операции: 28.09.2018 21:46, Тип операции: Эмиссия. Безналичная покупка.
			//		Карта РНКО "Платежный Центр" (ООО) в чужом устройстве POS.,
			//		Место совершения операции: страна POL город GDANSK,
			//		Терминал ID:  30202157\POL\GDANSK\PIWNA 3 4\TIME OUT RESTAURANT\ 2101355403.
			//		Код авторизации: 889082. Сумма транзакции: 358.04 RUR.
			//		Конвертация валют (из валюты 358.04 RUR в валюту 5.46 USD) Курс операции: 65.5751 . Курс ЦБ: 65.5745 .
			
			СтрокаПоиска = "Дата совершения операции: ";
			Номер = СтрНайти(КомментарийОперации, СтрокаПоиска);
			Если Номер > 0 Тогда
				
				Дата = Сред(КомментарийОперации, Номер);
				Дата = Лев(Сред(Дата, СтрДлина(СтрокаПоиска) + 1), 16);
				
				ДатаОперации = Дата(Сред(Дата, 7, 4) + Сред(Дата, 4, 2) + Лев(Дата, 2)
					+ Сред(Дата, 12, 2) + Сред(Дата, 15, 2) + "00");
				
			Иначе
				
				ДатаОперации = Дата(Сред(ДатаОперации, 7, 4) + Сред(ДатаОперации, 4, 2) + Лев(ДатаОперации, 2));
				
				// В дате операции этого формата нет времени, поэтому просто прибавляем одну секунду, если операция в той же дате, что и предыдущая.
				Если ДатаОперации <> ТекущаяДатаОперации Тогда
					ТекущаяДатаОперации = ДатаОперации;
					ТекущееВремяОперации = 0;
				Иначе
					ТекущееВремяОперации = ТекущееВремяОперации + 1;
				КонецЕсли;
				
				ДатаОперации = ДатаОперации + ТекущееВремяОперации;
				
			КонецЕсли;
			
			Валюта = Неопределено;
			
			СтрокаПоиска = "Конвертация валют (из валюты";
			Номер = СтрНайти(КомментарийОперации, СтрокаПоиска);
			Если Номер > 0 Тогда
				
				ВалютаСумма = Сред(КомментарийОперации, Номер + СтрДлина(СтрокаПоиска));
				
				СтрокаПоиска = "в валюту";
				Номер = СтрНайти(ВалютаСумма, СтрокаПоиска);
				Если Номер > 0 Тогда
					
					ВалютаСумма = СокрЛП(Сред(ВалютаСумма, Номер + СтрДлина(СтрокаПоиска)));
					Номер = СтрНайти(ВалютаСумма, ")");
					Если Номер > 0 Тогда
						
						ВалютаСумма = Лев(ВалютаСумма, Номер - 1);
						Номер = СтрНайти(ВалютаСумма, " ");
						Если Номер > 0 Тогда
							
							Валюта 			= Сред(ВалютаСумма, Номер + 1);
							СуммаВВалюте 	= Число(Лев(ВалютаСумма, Номер - 1)) * ?(ЭтоСписание, -1, 1);
							
						КонецЕсли;
						
					КонецЕсли;
					
				КонецЕсли;
				
			КонецЕсли;
				
			Если Валюта = Неопределено Тогда
				
				Валюта 				= "RUR";
				СуммаВВалюте 		= Сумма;
				
			КонецЕсли;
			
		КонецЕсли;
		
		МенеджерЗаписи = РегистрыСведений.ФактическиеДвижения.СоздатьМенеджерЗаписи();
		МенеджерЗаписи.БанковскаяКарта 	= БанковскаяКарта;
		МенеджерЗаписи.Дата 			= ДатаОперации;
		МенеджерЗаписи.Валюта 			= Валюта;
		МенеджерЗаписи.Сумма 			= Сумма;
		МенеджерЗаписи.СуммаВВалюте 	= СуммаВВалюте;
		МенеджерЗаписи.Комментарий 		= КомментарийОперации;
		
		Для Каждого СтрокаТЗ Из ТаблицаОпределений Цикл
			
			Если СтрНайти(НРег(КомментарийОперации), НРег(СтрокаТЗ.Определение)) > 0
				Или НРег(МенеджерЗаписи.Валюта) = НРег(СтрокаТЗ.Определение)
			Тогда
				МенеджерЗаписи.Вид = СтрокаТЗ.Ссылка;
				Прервать;
			КонецЕсли;
			
		КонецЦикла;
		
		Если Не ЗначениеЗаполнено(МенеджерЗаписи.Вид) Тогда
			МенеджерЗаписи.Вид = Справочники.ВидыДоходовРасходов.Прочее;
		КонецЕсли;
		
		СтруктураПоиска.БанковскаяКарта = БанковскаяКарта;
		СтруктураПоиска.Дата 			= ДатаОперации;
		СтруктураПоиска.Валюта 			= Валюта;
		
		МассивСтрок = ТаблицаСуществующихЗаписей.НайтиСтроки(СтруктураПоиска);
		Если МассивСтрок.Количество() > 0 Тогда
			МенеджерЗаписи.Примечание = МассивСтрок[0].Примечание;
			МенеджерЗаписи.Вид = МассивСтрок[0].Вид;
		КонецЕсли;
		
		МенеджерЗаписи.Записать(Истина);
		
	КонецЦикла;
	
КонецПроцедуры // Загрузить()

//----------------------------------------------------------------------------------------------------------------------------------------------

&НаСервере
Функция ПолучитьСуммуИВалюту(пСтрокаСуммы)
	
	Валюта = Лев(Прав(пСтрокаСуммы, 4), 3);
	
	СтрокаСуммы = СтрЗаменить(пСтрокаСуммы, "(" + Валюта + ")", "");
	СтрокаСуммы = СтрЗаменить(СтрокаСуммы, " ", "");
	Сумма = Число(СтрокаСуммы);
	
	Возврат Новый Структура("Валюта, Сумма", Валюта, Сумма);
	
КонецФункции // ПолучитьСуммуИВалюту()

//==============================================================================================================================================
// ОПЕРАТОРЫ ОСНОВНОЙ ПРОГРАММЫ
//==============================================================================================================================================

